buildrelease
[openafs-wiki.git] / TWiki / TWikiSystemRequirements.mdwn
1 <div>
2   <ul>
3     <li><a href="#TWiki System Requirements"> TWiki System Requirements</a><ul>
4         <li><a href="#Server Requirements"> Server Requirements</a><ul>
5             <li><a href="#Required CPAN Modules"> Required CPAN Modules</a></li>
6             <li><a href="#Optional CPAN Modules"> Optional CPAN Modules</a></li>
7           </ul>
8         </li>
9         <li><a href="#Client Requirements"> Client Requirements</a></li>
10         <li><a href="#Important note about TWiki Plugi"> Important note about TWiki Plugins</a></li>
11       </ul>
12     </li>
13   </ul>
14 </div>
15
16 # <a name="TWiki System Requirements"></a> TWiki System Requirements
17
18 _Server and client requirements_
19
20 Low client and server base requirements are core features that keep TWiki widely deployable, particularly across a range of browser platforms and versions. Many [[Plugins|TWiki:Plugins/PluginPackage]] and [[contrib modules|TWiki:Plugins/ContribPackage]] exist which enhance and expand TWiki's capabilities; they may have additional requirements.
21
22 ## <a name="Server Requirements"></a> Server Requirements
23
24 TWiki is written in Perl 5, uses a number of shell commands, and requires [RCS (Revision Control System)](http://www.gnu.org/software/rcs/rcs.html), a GNU Free Software package. TWiki is developed in a basic Linux/Apache environment. It also works with Microsoft Windows, and should have no problem on any other platform that meets the requirements.
25
26 <table border="1" cellpadding="0" cellspacing="0">
27   <tr>
28     <th bgcolor="#99CCCC"><strong> Resource </strong></th>
29     <th bgcolor="#99CCCC"><strong> Required Server Environment * </strong></th>
30   </tr>
31   <tr>
32     <td> Perl </td>
33     <td> 5.005_03 or higher (5.8.4 or higher is recommended) </td>
34   </tr>
35   <tr>
36     <td> RCS </td>
37     <td> 5.7 or higher (including GNU <code>diff</code>) %BR% Optional, TWiki includes a pure perl implementation of RCS that can be used instead (although it's slower) </td>
38   </tr>
39   <tr>
40     <td> GNU <code>diff</code></td>
41     <td> GNU <code>diff</code> 2.7 or higher is required when not using the all-Perl RcsLite. %BR% Install on PATH if not included with RCS (check version with <code>diff -v</code>) %BR% Must be the version used by RCS, to avoid problems with binary attachments - RCS may have hard-coded path to <code>diff</code></td>
42   </tr>
43   <tr>
44     <td> GNU <code>patch</code></td>
45     <td> For upgrades only: GNU <code>patch</code> is required when using the TWiki:Codev.UpgradeTWiki script </td>
46   </tr>
47   <tr>
48     <td> Other external programs </td>
49     <td><code>fgrep, egrep</code></td>
50   </tr>
51   <tr>
52     <td> Cron/scheduler </td>
53     <td> %BULLET% Unix: <code>cron</code> %BB% Windows: <code>cron</code> equivalents </td>
54   </tr>
55   <tr>
56     <td> Web server </td>
57     <td> Apache is well supported; see TWiki:TWiki.InstallingTWiki#OtherWebServers for other servers </td>
58   </tr>
59 </table>
60
61 ### <a name="Required CPAN Modules"></a> Required CPAN Modules
62
63 The following Perl modules are used by TWiki:
64
65 <table border="1" cellpadding="0" cellspacing="0">
66   <tr>
67     <th bgcolor="#99CCCC"><strong> Module </strong></th>
68     <th bgcolor="#99CCCC"><strong> Preferred version </strong></th>
69   </tr>
70   <tr>
71     <td> Algorithm::Diff (included) </td>
72     <td>   </td>
73   </tr>
74   <tr>
75     <td> CGI::Carp </td>
76     <td> &gt;=1.26 </td>
77   </tr>
78   <tr>
79     <td> Config </td>
80     <td> &gt;=0 </td>
81   </tr>
82   <tr>
83     <td> Cwd </td>
84     <td> &gt;=3.05 </td>
85   </tr>
86   <tr>
87     <td> Data::Dumper </td>
88     <td> &gt;=2.121 </td>
89   </tr>
90   <tr>
91     <td> Error (included) </td>
92     <td>   </td>
93   </tr>
94   <tr>
95     <td> File::Copy </td>
96     <td> &gt;=2.06 </td>
97   </tr>
98   <tr>
99     <td> File::Find </td>
100     <td> &gt;=1.05 </td>
101   </tr>
102   <tr>
103     <td> File::Spec </td>
104     <td> &gt;=3.05 </td>
105   </tr>
106   <tr>
107     <td> FileHandle </td>
108     <td> &gt;=2.01 </td>
109   </tr>
110   <tr>
111     <td> IO::File </td>
112     <td> &gt;=1.10 </td>
113   </tr>
114   <tr>
115     <td> Text::Diff (included) </td>
116     <td>   </td>
117   </tr>
118   <tr>
119     <td> Time::Local </td>
120     <td> &gt;=1.11 </td>
121   </tr>
122 </table>
123
124 ### <a name="Optional CPAN Modules"></a> Optional CPAN Modules
125
126 The following Perl modules may be used by TWiki:
127
128 <table border="1" cellpadding="0" cellspacing="0">
129   <tr>
130     <th bgcolor="#99CCCC"><strong> Module </strong></th>
131     <th bgcolor="#99CCCC"><strong> Preferred version </strong></th>
132     <th bgcolor="#99CCCC"><strong> Description </strong></th>
133   </tr>
134   <tr>
135     <td> CGI::Cookie </td>
136     <td> &gt;=1.24 </td>
137     <td> Used for session support </td>
138   </tr>
139   <tr>
140     <td> CGI::Session </td>
141     <td> &gt;=3.95 </td>
142     <td> Used for session support </td>
143   </tr>
144   <tr>
145     <td> Digest::base </td>
146     <td>   </td>
147     <td>   </td>
148   </tr>
149   <tr>
150     <td> Digest::SHA1 </td>
151     <td>   </td>
152     <td>   </td>
153   </tr>
154   <tr>
155     <td> Jcode </td>
156     <td>   </td>
157     <td> Used for [[Main/I18N]] support with perl 5.6 </td>
158   </tr>
159   <tr>
160     <td> Locale::Maketext::Lexicon </td>
161     <td> &gt;=0 </td>
162     <td> Used for [[Main/I18N]] support </td>
163   </tr>
164   <tr>
165     <td> Net::SMTP </td>
166     <td> &gt;=2.29 </td>
167     <td> Used for sending mail </td>
168   </tr>
169   <tr>
170     <td> Unicode::Map </td>
171     <td>   </td>
172     <td> Used for [[Main/I18N]] support with perl 5.6 </td>
173   </tr>
174   <tr>
175     <td> Unicode::Map8 </td>
176     <td>   </td>
177     <td> Used for [[Main/I18N]] support with perl 5.6 </td>
178   </tr>
179   <tr>
180     <td> Unicode::MapUTF8 </td>
181     <td>   </td>
182     <td> Used for [[Main/I18N]] support with perl 5.6 </td>
183   </tr>
184   <tr>
185     <td> Unicode::String </td>
186     <td>   </td>
187     <td> Used for [[Main/I18N]] support with perl 5.6 </td>
188   </tr>
189   <tr>
190     <td> URI </td>
191     <td>   </td>
192     <td> Used for configure </td>
193   </tr>
194 </table>
195
196 Most of them will probably already be available in your installation. You can check version numbers with the `configure` script, or if you're still trying to get to that point, check from the command line like this:
197
198     perl -e 'use FileHandle; print $FileHandle::VERSION."\n"'
199
200 <a name="ClientRequirements"></a>
201
202 ## <a name="Client Requirements"></a> Client Requirements
203
204 The TWiki [[standard installation|Main/TWikiInstallationGuide]] has relatively low browser requirements:
205
206 - HTML 3.2 compliant
207 - Cookies, if persistent sessions are required
208
209 CSS and Javascript are used in most skins, although there is a low-fat skin (Classic skin) available that minimises these requirements. Some skins will require more recent releases of browsers. The default skin (Pattern) is tested on IE 6, Safari, and Mozilla 5.0 based browsers (such as Firefox).
210
211 You can easily select a balance of browser capability versus look and feel. Try the installed skins at [[TWikiSkinBrowser]] and more at TWiki:Plugins.SkinPackage.
212
213 ## <a name="Important note about TWiki Plugi"></a> Important note about TWiki Plugins
214
215 - Plugins can require just about anything - browser-specific functions, stylesheets (CSS), Java applets, cookies, specific Perl modules,... - check the individual Plugin specs.
216   - **_%T% Note:_** Plugins included in the TWiki distribution do not add requirements, except for the [[CommentPlugin]] which requires Perl 5.6.1.
217
218 **_Related Topics:_** [[AdminDocumentationCategory]]